#include <p18f452.h>
#include "Curseurs.h"
#include "LCD.h"
#include "GameGirl.h"
#include <delays.h>

void Curseur_X(int x, int y);
void Efface_Curseur_X(int x, int y);
void Curseur_O(int x, int y);
void Efface_Curseur_O(int x, int y);
void Deplacement_Curseur(void);
void Init_Grille(void);
unsigned char fin_partie(void);
void Init_plateau(void);

unsigned char plateau[3][3]=	{	0,0,0,
									0,0,0,
									0,0,0	};
unsigned char match_nul=0;

void Curseur_X(int x, int y)
{
		LCD_PutPixel(x,y);							//Affiche le pixel
		LCD_PutPixel(x+1,y+1);
		LCD_PutPixel(x+2,y+2);
		LCD_PutPixel(x+3,y+3);
		LCD_PutPixel(x+1,y-1);
		LCD_PutPixel(x+2,y-2);
		LCD_PutPixel(x+3,y-3);
		LCD_PutPixel(x-1,y+1);
		LCD_PutPixel(x-2,y+2);
		LCD_PutPixel(x-3,y+3);
		LCD_PutPixel(x-1,y-1);
		LCD_PutPixel(x-2,y-2);
		LCD_PutPixel(x-3,y-3);
		LCD_PutPixel(x+4,y+4);
		LCD_PutPixel(x+4,y-4);
		LCD_PutPixel(x-4,y-4);
		LCD_PutPixel(x-4,y+4);	
}	

void Efface_Curseur_X(int x, int y)
{
		LCD_PutPasPixel(x,y);							//Affiche le pixel
		LCD_PutPasPixel(x+1,y+1);
		LCD_PutPasPixel(x+2,y+2);
		LCD_PutPasPixel(x+3,y+3);
		LCD_PutPasPixel(x+1,y-1);
		LCD_PutPasPixel(x+2,y-2);
		LCD_PutPasPixel(x+3,y-3);
		LCD_PutPasPixel(x-1,y+1);
		LCD_PutPasPixel(x-2,y+2);
		LCD_PutPasPixel(x-3,y+3);
		LCD_PutPasPixel(x-1,y-1);
		LCD_PutPasPixel(x-2,y-2);
		LCD_PutPasPixel(x-3,y-3);
		LCD_PutPasPixel(x+4,y+4);
		LCD_PutPasPixel(x+4,y-4);
		LCD_PutPasPixel(x-4,y-4);
		LCD_PutPasPixel(x-4,y+4);	
}

void Curseur_O(int x, int y)
{
		LCD_PutPixel(x+5,	y);
		LCD_PutPixel(x+5,	y+1);
		LCD_PutPixel(x+5,	y-1);

		LCD_PutPixel(x-5,	y);
		LCD_PutPixel(x-5,	y+1);
		LCD_PutPixel(x-5,	y-1);

		LCD_PutPixel(x,		y+4);
		LCD_PutPixel(x+1,	y+4);
		LCD_PutPixel(x+2,	y+4);
		LCD_PutPixel(x-1,	y+4);
		LCD_PutPixel(x-2,	y+4);

		LCD_PutPixel(x,		y-4);
		LCD_PutPixel(x+1,	y-4);
		LCD_PutPixel(x+2,	y-4);
		LCD_PutPixel(x-1,	y-4);
		LCD_PutPixel(x-2,	y-4);

		LCD_PutPixel(x+3,	y+3);
		LCD_PutPixel(x+3,	y-3);
		LCD_PutPixel(x-3,	y+3);
		LCD_PutPixel(x-3,	y-3);

		LCD_PutPixel(x+4,	y+2);
		LCD_PutPixel(x+4,	y-2);
		LCD_PutPixel(x-4,	y+2);
		LCD_PutPixel(x-4,	y-2);
}	

void Efface_Curseur_O(int x, int y)
{
		LCD_PutPasPixel(x+5,	y);
		LCD_PutPasPixel(x+5,	y+1);
		LCD_PutPasPixel(x+5,	y-1);

		LCD_PutPasPixel(x-5,	y);
		LCD_PutPasPixel(x-5,	y+1);
		LCD_PutPasPixel(x-5,	y-1);

		LCD_PutPasPixel(x,		y+4);
		LCD_PutPasPixel(x+1,	y+4);
		LCD_PutPasPixel(x+2,	y+4);
		LCD_PutPasPixel(x-1,	y+4);
		LCD_PutPasPixel(x-2,	y+4);

		LCD_PutPasPixel(x,		y-4);
		LCD_PutPasPixel(x+1,	y-4);
		LCD_PutPasPixel(x+2,	y-4);
		LCD_PutPasPixel(x-1,	y-4);
		LCD_PutPasPixel(x-2,	y-4);

		LCD_PutPasPixel(x+3,	y+3);
		LCD_PutPasPixel(x+3,	y-3);
		LCD_PutPasPixel(x-3,	y+3);
		LCD_PutPasPixel(x-3,	y-3);

		LCD_PutPasPixel(x+4,	y+2);
		LCD_PutPasPixel(x+4,	y-2);
		LCD_PutPasPixel(x-4,	y+2);
		LCD_PutPasPixel(x-4,	y-2);
}	

void Deplacement_Curseur(void)
{
	static unsigned char joueur=0;
	unsigned char deplacement=0;
	static unsigned char f=1,g=1;
	static int X=63, Y=32;
	if(!BOUTON_JAUNE)
	{
		X=63; Y=32;
		LCD_Clear();
		Init_plateau();
		Init_Grille();
		match_nul=0;
		f=1;g=1;
	}
	if(joueur==0)
		{
			if(Joystick_X()>156)	
			{
				Efface_Curseur_X(X,Y);
				while (Joystick_X()>156);
				deplacement=1;
				if(g<2) 
					
					g++;
				X=X+42;
					
			}				//Dplace le curseur en X...
			if(Joystick_X()<-156)	
			{
				Efface_Curseur_X(X,Y);
				while (Joystick_X()<-156);
				deplacement=1;
				if(g>0)	
				
					g--;
				X=X-42;
					
			}
			if(Joystick_Y()>156)	
			{
				Efface_Curseur_X(X,Y);
				while (Joystick_Y()>156);
				deplacement=1;
				
				if(f>0)
				
					f--;
				Y=Y-21;
				
			}				//...Puis en Y
			if(Joystick_Y()<-156)	
			{
				Efface_Curseur_X(X,Y);
				while (Joystick_Y()<-156);
				deplacement=1;
				if(f<2)	
				
					f++;
				Y=Y+21;
				
			}	
			if(X<4)		X=21;							//Vrifie qu'on ne sort pas de l'cran
			if(X>123)	X=105;	
			if(Y<4)		Y=11;							//Pareil en Y
			if(Y>59)	Y=53;
		
			if((!BOUTON_ROUGE)&&plateau[f][g]==0)
			{
				while(BOUTON_ROUGE);
				plateau[f][g]=1;
				joueur=~joueur;
				match_nul++;
			}
			if(deplacement==1)	
			{
				Init_Grille();
				deplacement=0;
			}
			Curseur_X(X,Y);
			Delay10KTCYx(50);
			Init_Grille();
			Efface_Curseur_X(X,Y);
			Delay10KTCYx(50);	
		}
		else
		{
			if(Joystick_X()>156)	
			{
				Efface_Curseur_O(X,Y);
				while (Joystick_X()>156);
				deplacement=1;
				if(g<2)	
				
					g++;
				X=X+42;
					
			}				//Dplace le curseur en X...
			if(Joystick_X()<-156)	
			{
				Efface_Curseur_O(X,Y);
				while (Joystick_X()<-156);
				deplacement=1;
				if(g>0)	
				
					g--;
				X=X-42;
					
			}
			if(Joystick_Y()>156)	
			{
				Efface_Curseur_O(X,Y);
				while (Joystick_Y()>156);
				deplacement=1;
				if(f>0)	
				
					f--;
				Y=Y-21;
					
			}				//...Puis en Y
			if(Joystick_Y()<-156)	
			{
				Efface_Curseur_O(X,Y);
				while (Joystick_Y()<-156);
				deplacement=1;
				if(f<2)	
				
					f++;
				Y=Y+21;
								
			}	
			if(X<4)		X=21;							//Vrifie qu'on ne sort pas de l'cran
			if(X>123)	X=105;	
			if(Y<4)		Y=11;							//Pareil en Y
			if(Y>59)	Y=53;
			
			if((!BOUTON_ROUGE)&&plateau[f][g]==0)
			{
				while(BOUTON_ROUGE);
				plateau[f][g]=2;
				joueur=~joueur;
				match_nul++;
			}
			if(deplacement==1) {Init_Grille();deplacement=0;};
			Curseur_O(X,Y);
			Delay10KTCYx(50);
			Init_Grille();
			Efface_Curseur_O(X,Y);
			Delay10KTCYx(50);
	}	
		
}

void Init_Grille(void)
{
	unsigned char a,b,k,l;
	
	for(a=0;a<128;a++)
	{
		LCD_PutPixel(a,22);
		LCD_PutPixel(a,44);
	}
	for(b=0;b<64;b++)
	{
		LCD_PutPixel(42,b);
		LCD_PutPixel(84,b);
	}
	for(k=0;k<3;k++)
	{
		for(l=0;l<3;l++)		
		{
			if(plateau[l][k])
			{
				if(plateau[l][k]==1)	Curseur_X((21+k*42),(11+l*21));
				if(plateau[l][k]==2)	Curseur_O((21+k*42),(11+l*21));
			}
		}
	}
}

unsigned char fin_partie(void)
{
	unsigned char m=0,n=0,putc,gagnant=0;
	for(n=0;n<3;n++)
	{	
		if((plateau[n][m]==1)&&(plateau[n][m+1]==1)&&(plateau[n][m+2]==1))
		{
			gagnant=1;	
		}
		if((plateau[n][m]==2)&&(plateau[n][m+1]==2)&&(plateau[n][m+2]==2))
		{
			gagnant=2;	
		}
	}
	n=0;
	for(m=0;m<3;m++)
	{	
		if((plateau[n][m]==1)&&(plateau[n+1][m]==1)&&(plateau[n+2][m]==1))
		{
			gagnant=1;	
		}
		if((plateau[n][m]==2)&&(plateau[n+1][m]==2)&&(plateau[n+2][m]==2))
		{
			gagnant=2;	
		}
	}
	m=0;
	if(((plateau[n][m]==1)&&(plateau[n+1][m+1]==1)&&(plateau[n+2][m+2]==1))
		||((plateau[n][m+2]==1)&&(plateau[n+1][m+1]==1)&&(plateau[n+2][m]==1)))
		gagnant=1;
	if(((plateau[n][m]==2)&&(plateau[n+1][m+1]==2)&&(plateau[n+2][m+2]==2))
		||((plateau[n][m+2]==2)&&(plateau[n+1][m+1]==2)&&(plateau[n+2][m]==2)))
		gagnant=2;
	if(gagnant!=0)
		{
			LCD_Clear();
			LCD_GotoXY(30,4);
			LCD_Putchar('L');
			LCD_Putchar('e');
			LCD_Putchar('s');
			LCD_Putchar(' ');
			if(gagnant==1)	
				LCD_Putchar('X');
			else
				LCD_Putchar('O');
	
			LCD_GotoXY(64,4);
			LCD_Putchar('g');
			LCD_Putchar('a');
			LCD_Putchar('g');
			LCD_Putchar('n');
			LCD_Putchar('e');
			LCD_Putchar('n');
			LCD_Putchar('t');
			LCD_Putchar(' ');				
			LCD_Putchar('!');

			while(!BOUTON_ROUGE);
			Init_Grille();	
			while(BOUTON_JAUNE);	
		}
	if((match_nul==9)&&(gagnant==0))
		{
			LCD_Clear();
			LCD_GotoXY(30,4);
			LCD_Putchar('M');
			LCD_Putchar('a');
			LCD_Putchar('t');
			LCD_Putchar('c');
			LCD_Putchar('h');
			LCD_Putchar(' ');
			LCD_GotoXY(64,4);
			LCD_Putchar('n');
			LCD_Putchar('u');
			LCD_Putchar('l');
			while(BOUTON_JAUNE)
			{
				Init_Grille();	
			}
			match_nul=0;

		}
	
}

void Init_plateau(void)
{
	unsigned char tabx,taby;
	for(tabx=0;tabx<3;tabx++)
		for(taby=0;taby<3;taby++)
			plateau[taby][tabx]=0;
}
