#include <adc.h>
#include <p18f452.h>
#include <delays.h>

#include "GameGirl.h"

void ConfigProcessor(void);
int Joystick_X(void);
int Joystick_Y(void);

//Position de dpart du joystick
int Joystick_X_Zero=512;
int Joystick_Y_Zero=512;

//Configure l'tat des ports du processeur en entre ou en sortie/ 0->sortie /1->entre
void ConfigProcessor(void)
{
	TRIS_LED_VERTE 		= 0;		//En sortie pour commander la led verte
	TRIS_LED_ROUGE 		= 0;		//En sortie pour commander la led rouge
	TRIS_BOUTON_VERT 	= 1;		//En entre pour le BP vert
	TRIS_BOUTON_BLEU 	= 1;		//En entre pour le BP bleu
	TRIS_BOUTON_ROUGE 	= 1;		//En entre pour le BP rouge
	TRIS_BOUTON_JAUNE	= 1;		//En entre pour le BP jaune
	OpenADC (	ADC_FOSC_2 &		//config du CAN
				ADC_RIGHT_JUST &
				ADC_3ANA_0REF ,		//AN0 et AN1 entres analogiques
				ADC_INT_OFF );

	/*OpenADC (	ADC_FOSC_2 &
				ADC_RIGHT_JUST &
				ADC_0ANA_0REF ,
				ADC_INT_OFF );*/
}

int Joystick_X(void)
{
	int position_X		=Joystick_X_Zero;	//Position du curseur en X
	SetChanADC(ADC_CH1);					//Conversion sur la voie AN1
	Delay10TCYx(5);							//Attendre 50 cycles
	ConvertADC();							//Lance la conversion
	while(BusyADC());						//Attend la fin de conversion
	position_X			=ReadADC()-512;		//Dcalage pour etre compris entre -512 et +511 
	return(-position_X);					//Renvoie la position de X
}

int Joystick_Y(void)
{
	int position_Y		=Joystick_X_Zero;	//Position du curseur en Y
	SetChanADC(ADC_CH0);					//Conversion sur la voie AN0
	Delay10TCYx(5);							//Attendre 50 cycles
	ConvertADC();							//Lance la conversion
	while(BusyADC());						//Attend la fin de conversion
	position_Y			=ReadADC()-512;		//Dcalage pour etre compris entre -512 et +511
	return(position_Y);						//Renvoie la position de Y
}
