#ifndef _LCD_
#define _LCD_

//Dfinitions des constantes et des prototypes des fonctions...

#define LCD_CSA				PORTBbits.RB1		//Slection du contrleur A
#define LCD_CSB				PORTBbits.RB2		//Slection du contrleur B 
#define LCD_RS				PORTBbits.RB3		//Slection du registre
#define LCD_RW				PORTBbits.RB4		//Lecture/Ecriture
#define LCD_ENABLE			PORTBbits.RB5		//Enable
#define LCD_DATA			PORTD				//Port de donnes
#define LCD_RESET			PORTBbits.RB0		//Reset
#define LCD_BACKLIGHT		PORTBbits.RB6		//Rtro-clairage

#define TRIS_LCD_CSA		TRISBbits.TRISB1	//Config du port du contrleur A 
#define TRIS_LCD_CSB		TRISBbits.TRISB2	//Config du port du contrleur B
#define TRIS_LCD_RS			TRISBbits.TRISB3	//Config du port du registre
#define TRIS_LCD_RW			TRISBbits.TRISB4	//Config du port de lecture/criture
#define TRIS_LCD_ENABLE		TRISBbits.TRISB5	//config du port de la broche ENABLE
#define TRIS_LCD_DATA		TRISD				//Config des ports de donne
#define TRIS_LCD_RESET		TRISBbits.TRISB0	//Config du port du la broche RESET
#define TRIS_LCD_BACKLIGHT	TRISBbits.TRISB6	//config du port de rtro-clairage


void LCD_Init (void);								//Initialisation de l'afficheur LCD

void LCD_Write_Command(unsigned char Data);			//Envoie d'une fonction a l'afficheur

void LCD_Send_Data(unsigned char Data);				//Envoie une donne a afficher

void LCD_Clear(void);								//Efface l'cran

void LCD_GotoXY(unsigned char X,unsigned char Y);	//Permet de dplacer le curseur  une position voulue

void LCD_Putchar(char ch);							//Permet d'envoyer un caractere sur l'cran

unsigned char LCD_ReadData(void);					//Permet de lire la valeur courante de la colonne du pointeur

void LCD_PutPixel(unsigned char X, unsigned char Y);//Permet de positionner un pixel sur l'cran a une position choisie

void LCD_PutPasPixel(unsigned char X, unsigned char Y);




#endif
